import { type ResolveConflictsType, SemanticsType, type Vertex } from "../index.js";
import type { DRPPublicCredential } from "../interface.js";
import { type ACL, ACLConflictResolution, ACLGroup } from "./interface.js";
export declare class ObjectACL implements ACL {
    semanticsType: SemanticsType;
    permissionless: boolean;
    private _conflictResolution;
    private _admins;
    private _finalitySigners;
    private _writers;
    constructor(options: {
        admins: Map<string, DRPPublicCredential>;
        permissionless?: boolean;
        conflictResolution?: ACLConflictResolution;
    });
    grant(senderId: string, peerId: string, publicKey: DRPPublicCredential, group: ACLGroup): void;
    revoke(senderId: string, peerId: string, group: ACLGroup): void;
    query_getFinalitySigners(): Map<string, DRPPublicCredential>;
    query_isAdmin(peerId: string): boolean;
    query_isFinalitySigner(peerId: string): boolean;
    query_isWriter(peerId: string): boolean;
    query_getPeerKey(peerId: string): DRPPublicCredential | undefined;
    resolveConflicts(vertices: Vertex[]): ResolveConflictsType;
}
//# sourceMappingURL=index.d.ts.map