import type { DRPPublicCredential } from "../interface.js";
import type { DRP } from "../interface.js";
export interface ACL extends DRP {
    permissionless: boolean;
    grant: (senderId: string, peerId: string, publicKey: DRPPublicCredential, group: ACLGroup) => void;
    revoke: (senderId: string, peerId: string, group: ACLGroup) => void;
    query_getFinalitySigners: () => Map<string, DRPPublicCredential>;
    query_isAdmin: (peerId: string) => boolean;
    query_isFinalitySigner: (peerId: string) => boolean;
    query_isWriter: (peerId: string) => boolean;
    query_getPeerKey: (peerId: string) => DRPPublicCredential | undefined;
}
export declare enum ACLConflictResolution {
    GrantWins = 0,
    RevokeWins = 1
}
export declare enum ACLGroup {
    Admin = "ADMIN",
    Finality = "FINALITY",
    Writer = "WRITER"
}
//# sourceMappingURL=interface.d.ts.map