function kahnsAlgorithm(origin, subgraph) {
    const result = [];
    const inDegree = new Map();
    const queue = [];
    for (const hash of subgraph.entries()) {
        inDegree.set(hash, 0);
    }
    for (const [vertex, children] of this.forwardEdges) {
        if (!inDegree.has(vertex))
            continue;
        for (const child of children) {
            if (!inDegree.has(child))
                continue;
            inDegree.set(child, (inDegree.get(child) || 0) + 1);
        }
    }
    let head = 0;
    queue.push(origin);
    while (queue.length > 0) {
        const current = queue[head];
        head++;
        if (!current)
            continue;
        result.push(current);
        for (const child of this.forwardEdges.get(current) || []) {
            if (!inDegree.has(child))
                continue;
            const inDegreeValue = inDegree.get(child) || 0;
            inDegree.set(child, inDegreeValue - 1);
            if (inDegreeValue - 1 === 0) {
                queue.push(child);
            }
        }
        if (head > queue.length / 2) {
            queue.splice(0, head);
            head = 0;
        }
    }
    return result;
}
export {};
