import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
export declare const protobufPackage = "drp.object.v1";
/** Supposed to be the RIBLT stuff */
export interface Vertex {
    hash: string;
    peerId: string;
    operation: Vertex_Operation | undefined;
    dependencies: string[];
    timestamp: number;
    signature: Uint8Array;
}
export interface Vertex_Operation {
    drpType: string;
    opType: string;
    value: any | undefined;
}
export interface Attestation {
    data: string;
    signature: Uint8Array;
}
export interface AggregatedAttestation {
    data: string;
    signature: Uint8Array;
    aggregationBits: Uint8Array;
}
export interface DRPStateEntry {
    key: string;
    value: any | undefined;
}
export interface DRPState {
    state: DRPStateEntry[];
}
export interface DRPObjectBase {
    id: string;
    vertices: Vertex[];
}
export declare const Vertex: MessageFns<Vertex>;
export declare const Vertex_Operation: MessageFns<Vertex_Operation>;
export declare const Attestation: MessageFns<Attestation>;
export declare const AggregatedAttestation: MessageFns<AggregatedAttestation>;
export declare const DRPStateEntry: MessageFns<DRPStateEntry>;
export declare const DRPState: MessageFns<DRPState>;
export declare const DRPObjectBase: MessageFns<DRPObjectBase>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
//# sourceMappingURL=object_pb.d.ts.map