export interface HeapInterface<T> {
    length(): number;
    less(i: number, j: number): boolean;
    swap(i: number, j: number): void;
    push(item: T): void;
    pop(): T | undefined;
}
export declare class Heap<T> {
    private readonly _heap;
    constructor(heap: HeapInterface<T>);
    length(): number;
    push(item: T): void;
    pop(): T | undefined;
    remove(i: number): T | undefined;
    siftUp(i: number): void;
    siftDown(i: number, n: number): void;
    swap(i: number, j: number): void;
}
//# sourceMappingURL=heap.d.ts.map