export interface HeapInterface<T> {
    length(): number;
    less(i: number, j: number): boolean;
    swap(i: number, j: number): void;
    push(item: T): void;
    pop(): T | undefined;
}
export declare class Heap<T> {
    static push<T>(h: HeapInterface<T>, item: T): void;
    static pop<T>(h: HeapInterface<T>): T | undefined;
    static remove<T>(h: HeapInterface<T>, i: number): T | undefined;
    static siftUp<T>(h: HeapInterface<T>, i: number): void;
    static siftDown<T>(h: HeapInterface<T>, i: number, n: number): void;
    static swap<T>(h: HeapInterface<T>, i: number, j: number): void;
}
//# sourceMappingURL=priorityQueue.d.ts.map